searchNodes=[{"ref":"Phoenix.Ecto.html","title":"Phoenix.Ecto","type":"module","doc":"Integrates Phoenix with Ecto. It implements many protocols that makes it easier to use Ecto with Phoenix either when working with HTML or JSON."},{"ref":"Phoenix.Ecto.html#start/2","title":"Phoenix.Ecto.start/2","type":"function","doc":"Called when an application is started. This function is called when an application is started using Application.start/2 (and functions on top of that, such as Application.ensure_started/2). This function should start the top-level process of the application (which should be the top supervisor of the application&#39;s supervision tree if the application follows the OTP design principles around supervision). start_type defines how the application is started: :normal - used if the startup is a normal startup or if the application is distributed and is started on the current node because of a failover from another node and the application specification key :start_phases is :undefined. {:takeover, node} - used if the application is distributed and is started on the current node because of a failover on the node node. {:failover, node} - used if the application is distributed and is started on the current node because of a failover on node node, and the application specification key :start_phases is not :undefined. start_args are the arguments passed to the application in the :mod specification key (e.g., mod: {MyApp, [:my_args]}). This function should either return {:ok, pid} or {:ok, pid, state} if startup is successful. pid should be the PID of the top supervisor. state can be an arbitrary term, and if omitted will default to []; if the application is later stopped, state is passed to the stop/1 callback (see the documentation for the c:stop/1 callback for more information). use Application provides no default implementation for the start/2 callback. Callback implementation for Application.start/2."},{"ref":"Phoenix.Ecto.CheckRepoStatus.html","title":"Phoenix.Ecto.CheckRepoStatus","type":"module","doc":"A plug that does some checks on your application repos. Checks if the storage is up (database is created) or if there are any pending migrations. Both checks can raise an error if the conditions are not met. Plug options :otp_app - name of the application which the repos are fetched from :get_migration_function - function that returns the migrations for a given repo. Should return a list of tuples with three elements, e.g. [{state :: :up | :down, version :: integer(), name :: String.t()]] If ecto_sql dependency is loaded, uses Ecto.Migrator.migrations/1 by default."},{"ref":"Phoenix.Ecto.CheckRepoStatus.html#call/2","title":"Phoenix.Ecto.CheckRepoStatus.call/2","type":"function","doc":"Callback implementation for Plug.call/2."},{"ref":"Phoenix.Ecto.CheckRepoStatus.html#init/1","title":"Phoenix.Ecto.CheckRepoStatus.init/1","type":"function","doc":"Callback implementation for Plug.init/1."},{"ref":"Phoenix.Ecto.PendingMigrationError.html","title":"Phoenix.Ecto.PendingMigrationError","type":"exception","doc":""},{"ref":"Phoenix.Ecto.PendingMigrationError.html#message/1","title":"Phoenix.Ecto.PendingMigrationError.message/1","type":"function","doc":"Callback implementation for Exception.message/1."},{"ref":"Phoenix.Ecto.SQL.Sandbox.html","title":"Phoenix.Ecto.SQL.Sandbox","type":"module","doc":"A plug to allow concurrent, transactional acceptance tests with [Ecto.Adapters.SQL.Sandbox] (https://hexdocs.pm/ecto_sql/Ecto.Adapters.SQL.Sandbox.html). Example This plug should only be used during tests. First, set a flag to enable it in config/test.exs: config :your_app, sql_sandbox: true And use the flag to conditionally add the plug to lib/your_app/endpoint.ex: if Application.get_env(:your_app, :sql_sandbox) do plug Phoenix.Ecto.SQL.Sandbox end It&#39;s important that this is at the top of endpoint.ex, before any other plugs. Then, within an acceptance test, checkout a sandboxed connection as before. Use metadata_for/2 helper to get the session metadata to that will allow access to the test&#39;s connection. Here&#39;s an example using Hound: use Hound.Helpers setup do :ok = Ecto.Adapters.SQL.Sandbox.checkout(YourApp.Repo) metadata = Phoenix.Ecto.SQL.Sandbox.metadata_for(YourApp.Repo, self()) Hound.start_session(metadata: metadata) :ok end Concurrent end-to-end tests with external clients Concurrent and transactional tests for external HTTP clients is supported, allowing for complete end-to-end tests. This is useful for cases such as JavaScript test suites for single page applications that exercise the Phoenix endpoint for end-to-end test setup and teardown. To enable this, you can expose a sandbox route on the Phoenix.Ecto.SQL.Sandbox plug by providing the :at, and :repo options. For example: plug Phoenix.Ecto.SQL.Sandbox, at: &quot;/sandbox&quot;, repo: MyApp.Repo, timeout: 15_000 # the default This would expose a route at &quot;/sandbox&quot; for the given repo where external clients send POST requests to spawn a new sandbox session, and DELETE requests to stop an active sandbox session. By default, the external client is expected to pass up the &quot;user-agent&quot; header containing serialized sandbox metadata returned from the POST request, but this value may customized with the :header option."},{"ref":"Phoenix.Ecto.SQL.Sandbox.html#call/2","title":"Phoenix.Ecto.SQL.Sandbox.call/2","type":"function","doc":""},{"ref":"Phoenix.Ecto.SQL.Sandbox.html#decode_metadata/1","title":"Phoenix.Ecto.SQL.Sandbox.decode_metadata/1","type":"function","doc":"Decodes encoded metadata back into map generated from metadata_for/2."},{"ref":"Phoenix.Ecto.SQL.Sandbox.html#encode_metadata/1","title":"Phoenix.Ecto.SQL.Sandbox.encode_metadata/1","type":"function","doc":"Encodes metadata generated by metadata_for/2 for client response."},{"ref":"Phoenix.Ecto.SQL.Sandbox.html#init/1","title":"Phoenix.Ecto.SQL.Sandbox.init/1","type":"function","doc":""},{"ref":"Phoenix.Ecto.SQL.Sandbox.html#metadata_for/2","title":"Phoenix.Ecto.SQL.Sandbox.metadata_for/2","type":"function","doc":"Returns metadata to associate with the session to allow the endpoint to access the database connection checked out by the test process."},{"ref":"Phoenix.Ecto.SQL.Sandbox.html#start_child/2","title":"Phoenix.Ecto.SQL.Sandbox.start_child/2","type":"function","doc":"Spawns a sandbox session to checkout a connection for a remote client. Examples iex&gt; {:ok, _owner_pid, metadata} = start_child(MyApp.Repo)"},{"ref":"Phoenix.Ecto.SQL.Sandbox.html#stop/1","title":"Phoenix.Ecto.SQL.Sandbox.stop/1","type":"function","doc":"Stops a sandbox session holding a connection for a remote client. Examples iex&gt; {:ok, owner_pid, metadata} = start_child(MyApp.Repo) iex&gt; :ok = stop(owner_pid)"},{"ref":"Phoenix.Ecto.StorageNotCreatedError.html","title":"Phoenix.Ecto.StorageNotCreatedError","type":"exception","doc":""},{"ref":"Phoenix.Ecto.StorageNotCreatedError.html#message/1","title":"Phoenix.Ecto.StorageNotCreatedError.message/1","type":"function","doc":"Callback implementation for Exception.message/1."},{"ref":"main.html","title":"Phoenix/Ecto","type":"extras","doc":"A project that integrates Phoenix with Ecto, implementing all relevant protocols."},{"ref":"main.html#usage","title":"Phoenix/Ecto - Usage","type":"extras","doc":"You can use phoenix_ecto in your projects in two steps: Add it to your mix.exs dependencies: def deps do [{:phoenix_ecto, &quot;~&gt; 4.0&quot;}] end List it as your application dependency: def application do [applications: [:logger, :phoenix_ecto]] end"},{"ref":"main.html#concurrent-browser-tests","title":"Phoenix/Ecto - Concurrent browser tests","type":"extras","doc":"This library also provides a plug called Phoenix.Ecto.SQL.Sandbox that allows developers to run acceptance tests powered by headless browsers such as Phantom.js and Selenium concurrently. If you are not familiar with Ecto&#39;s SQL sandbox, we recommend you to first get acquainted with it by reading Ecto.Adapters.SQL.Sandbox documentation. To enable concurrent acceptance tests, make sure you are using PostgreSQL and follow the instructions below: Set a flag to enable the sandbox in config/test.exs: config :your_app, sql_sandbox: true And use the flag to conditionally add the plug to lib/your_app/endpoint.ex: if Application.get_env(:your_app, :sql_sandbox) do plug Phoenix.Ecto.SQL.Sandbox end Make sure that this is placed before the line plug YourApp.Router (or any other plug that may access the database). You can now checkout a sandboxed connection and pass the connection information to an acceptance testing tool like Hound or Wallaby. Hound To write concurrent acceptance tests with Hound, first add it as a dependency to your mix.exs: {:hound, &quot;~&gt; 1.0&quot;} Make sure to start it at the top of your test/test_helper.exs: {:ok, _} = Application.ensure_all_started(:hound) Then add the following to your test case (or to your case template): use Hound.Helpers setup do :ok = Ecto.Adapters.SQL.Sandbox.checkout(YourApp.Repo) metadata = Phoenix.Ecto.SQL.Sandbox.metadata_for(YourApp.Repo, self()) Hound.start_session(metadata: metadata) :ok end Hound supports multiple drivers like Chrome, Firefox, etc but it does not support concurrent tests under PhantomJS (the default). Wallaby To write concurrent acceptance tests with Wallaby, first add it as a dependency to your mix.exs: {:wallaby, &quot;~&gt; 0.22&quot;} Make sure to start it at the top of your test/test_helper.exs: {:ok, _} = Application.ensure_all_started(:wallaby) Then add the following to your test case (or to your case template): use Wallaby.DSL setup do :ok = Ecto.Adapters.SQL.Sandbox.checkout(YourApp.Repo) metadata = Phoenix.Ecto.SQL.Sandbox.metadata_for(YourApp.Repo, self()) {:ok, session} = Wallaby.start_session(metadata: metadata) end Wallaby currently supports PhantomJS (including concurrent tests). Support for other drivers may be added in the future."},{"ref":"main.html#the-phoenix-ecto-integration","title":"Phoenix/Ecto - The Phoenix &lt;-&gt; Ecto integration","type":"extras","doc":"Thanks to Elixir protocols, the integration between Phoenix and Ecto is simply a matter of implementing a handful of protocols. We provide the following implementations: Phoenix.HTML.FormData protocol for Ecto.Changeset Phoenix.HTML.Safe protocol for Decimal Plug.Exception protocol for the relevant Ecto exceptions"},{"ref":"main.html#configuration","title":"Phoenix/Ecto - Configuration","type":"extras","doc":"The Plug.Exception implementations for Ecto exceptions may be disabled by including the error in the mix configuration. config :phoenix_ecto, exclude_ecto_exceptions_from_plug: [Ecto.NoResultsError]"},{"ref":"main.html#license","title":"Phoenix/Ecto - License","type":"extras","doc":"Same license as Phoenix."}]